Index: src/Tesselation/tesselation.cpp
===================================================================
--- src/Tesselation/tesselation.cpp	(revision 2a3124b519027c588e363ec4c5a44171b4715777)
+++ src/Tesselation/tesselation.cpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
@@ -2259,16 +2265,16 @@
                       }
                     } else {
-                      LOG(1, "REJECT: NewSphereCenter " << NewSphereCenter << " for " << *Candidate << " is too far away: " << radius << ".");
+                      LOG(3, "REJECT: NewSphereCenter " << NewSphereCenter << " for " << *Candidate << " is too far away: " << radius << ".");
                     }
                   }
                   catch (LinearDependenceException &excp){
-                    LOG(1, boost::diagnostic_information(excp));
-                    LOG(1, "REJECT: Three points from " << *CandidateLine.BaseLine << " and Candidate " << *Candidate << " are linear-dependent.");
+                    LOG(3, boost::diagnostic_information(excp));
+                    LOG(3, "REJECT: Three points from " << *CandidateLine.BaseLine << " and Candidate " << *Candidate << " are linear-dependent.");
                   }
                 } else {
                   if (ThirdPoint != NULL) {
-                    LOG(1, "REJECT: Base triangle " << *CandidateLine.BaseLine << " and " << *ThirdPoint << " contains Candidate " << *Candidate << ".");
+                    LOG(3, "REJECT: Base triangle " << *CandidateLine.BaseLine << " and " << *ThirdPoint << " contains Candidate " << *Candidate << ".");
                   } else {
-                    LOG(1, "REJECT: Base triangle " << *CandidateLine.BaseLine << " contains Candidate " << *Candidate << ".");
+                    LOG(3, "REJECT: Base triangle " << *CandidateLine.BaseLine << " contains Candidate " << *Candidate << ".");
                   }
                 }
@@ -2281,10 +2287,10 @@
   } else {
     if (ThirdPoint != NULL)
-      LOG(1, "Circumcircle for base line " << *CandidateLine.BaseLine << " and third node " << *ThirdPoint << " is too big!");
+      LOG(3, "Circumcircle for base line " << *CandidateLine.BaseLine << " and third node " << *ThirdPoint << " is too big!");
     else
-      LOG(1, "Circumcircle for base line " << *CandidateLine.BaseLine << " is too big!");
-  }
-
-  LOG(1, "INFO: Sorting candidate list ...");
+      LOG(3, "Circumcircle for base line " << *CandidateLine.BaseLine << " is too big!");
+  }
+
+  LOG(2, "DEBUG: Sorting candidate list ...");
   if (CandidateLine.pointlist.size() > 1) {
     CandidateLine.pointlist.unique();
@@ -2306,5 +2312,5 @@
 class BoundaryPointSet *Tesselation::GetCommonEndpoint(const BoundaryLineSet * line1, const BoundaryLineSet * line2) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   const BoundaryLineSet * lines[2] = { line1, line2 };
   class BoundaryPointSet *node = NULL;
@@ -2334,5 +2340,5 @@
 DistanceToPointMap * Tesselation::FindClosestBoundaryPointsToVector(const Vector &x, const LinkedCell_deprecated* LC) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   PointMap::const_iterator FindPoint;
   int N[NDIM], Nlower[NDIM], Nupper[NDIM];
@@ -2347,5 +2353,5 @@
   for (int i = 0; i < NDIM; i++) // store indices of this cell
     N[i] = LC->n[i];
-  LOG(1, "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << ".");
+  LOG(2, "DEBUG: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << ".");
   DistanceToPointMap * points = new DistanceToPointMap;
   LC->GetNeighbourBounds(Nlower, Nupper);
@@ -2360,5 +2366,5 @@
             if (FindPoint != PointsOnBoundary.end()) {
               points->insert(DistanceToPointPair(FindPoint->second->node->DistanceSquared(x), FindPoint->second));
-              LOG(1, "INFO: Putting " << *FindPoint->second << " into the list.");
+              LOG(3, "DEBUG: Putting " << *FindPoint->second << " into the list.");
             }
           }
@@ -2385,5 +2391,5 @@
 BoundaryLineSet * Tesselation::FindClosestBoundaryLineToVector(const Vector &x, const LinkedCell_deprecated* LC) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   // get closest points
   DistanceToPointMap * points = FindClosestBoundaryPointsToVector(x, LC);
@@ -2431,5 +2437,5 @@
   // check whether closest line is "too close" :), then it's inside
   if (ClosestLine == NULL) {
-    LOG(0, "Is the only point, no one else is closeby.");
+    LOG(2, "DEBUG: Is the only point, no one else is closeby.");
     return NULL;
   }
@@ -2445,5 +2451,5 @@
 TriangleList * Tesselation::FindClosestTrianglesToVector(const Vector &x, const LinkedCell_deprecated* LC) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   // get closest points
   DistanceToPointMap * points = FindClosestBoundaryPointsToVector(x, LC);
@@ -2511,5 +2517,5 @@
   // check whether closest line is "too close" :), then it's inside
   if (ClosestLines.empty()) {
-    LOG(0, "Is the only point, no one else is closeby.");
+    LOG(2, "DEBUG: Is the only point, no one else is closeby.");
     return NULL;
   }
@@ -2532,5 +2538,5 @@
 class BoundaryTriangleSet * Tesselation::FindClosestTriangleToVector(const Vector &x, const LinkedCell_deprecated* LC) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   class BoundaryTriangleSet *result = NULL;
   TriangleList *triangles = FindClosestTrianglesToVector(x, LC);
@@ -2595,5 +2601,5 @@
 double Tesselation::GetDistanceSquaredToTriangle(const Vector &Point, const BoundaryTriangleSet* const triangle) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   Vector Center;
   Vector helper;
@@ -2652,5 +2658,5 @@
 double Tesselation::GetDistanceToSurface(const Vector &Point, const LinkedCell_deprecated* const LC) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   TriangleIntersectionList Intersections(Point, this, LC);
 
@@ -2667,5 +2673,5 @@
 BoundaryTriangleSet * Tesselation::GetClosestTriangleOnSurface(const Vector &Point, const LinkedCell_deprecated* const LC) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   TriangleIntersectionList Intersections(Point, this, LC);
 
@@ -2682,5 +2688,5 @@
 TesselPointSet * Tesselation::GetAllConnectedPoints(const TesselPoint* const Point) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   TesselPointSet *connectedPoints = new TesselPointSet;
   class BoundaryPointSet *ReferencePoint = NULL;
@@ -2747,5 +2753,5 @@
 TesselPointList * Tesselation::GetCircleOfConnectedTriangles(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector &Reference) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   map<double, TesselPoint*> anglesOfPoints;
   TesselPointList *connectedCircle = new TesselPointList;
@@ -2773,5 +2779,5 @@
   }
   PlaneNormal.Scale(1.0 / triangles->size());
-  LOG(1, "INFO: Calculated PlaneNormal of all circle points is " << PlaneNormal << ".");
+  LOG(4, "DEBUG: Calculated PlaneNormal of all circle points is " << PlaneNormal << ".");
   PlaneNormal.Normalize();
 
@@ -2780,5 +2786,5 @@
   AngleZero.ProjectOntoPlane(PlaneNormal);
   if ((AngleZero.NormSquared() < MYEPSILON)) {
-    LOG(1, "Using alternatively " << (*SetOfNeighbours->begin())->getPosition() << " as angle 0 referencer.");
+    LOG(4, "DEBUG: Using alternatively " << (*SetOfNeighbours->begin())->getPosition() << " as angle 0 referencer.");
     AngleZero = ((*SetOfNeighbours->begin())->getPosition()) - (Point->getPosition());
     AngleZero.ProjectOntoPlane(PlaneNormal);
@@ -2788,10 +2794,10 @@
     }
   }
-  LOG(1, "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << ".");
+  LOG(4, "DEBUG: Reference vector on this plane representing angle 0 is " << AngleZero << ".");
   if (AngleZero.NormSquared() > MYEPSILON)
     OrthogonalVector = Plane(PlaneNormal, AngleZero,0).getNormal();
   else
     OrthogonalVector.MakeNormalTo(PlaneNormal);
-  LOG(1, "INFO: OrthogonalVector on plane is " << OrthogonalVector << ".");
+  LOG(4, "DEBUG: OrthogonalVector on plane is " << OrthogonalVector << ".");
 
   // go through all connected points and calculate angle
@@ -2800,5 +2806,5 @@
     helper.ProjectOntoPlane(PlaneNormal);
     double angle = GetAngle(helper, AngleZero, OrthogonalVector);
-    LOG(0, "INFO: Calculated angle is " << angle << " for point " << **listRunner << ".");
+    LOG(4, "DEBUG" << angle << " for point " << **listRunner << ".");
     anglesOfPoints.insert(pair<double, TesselPoint*> (angle, (*listRunner)));
   }
@@ -2824,5 +2830,5 @@
 TesselPointList * Tesselation::GetCircleOfSetOfPoints(TesselPointSet *SetOfNeighbours, const TesselPoint* const Point, const Vector &Reference) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   map<double, TesselPoint*> anglesOfPoints;
   TesselPointList *connectedCircle = new TesselPointList;
@@ -2859,5 +2865,5 @@
                    ((*TesselB)->getPosition()),
                    ((*TesselC)->getPosition())).getNormal();
-    LOG(0, "Making normal vector out of " << *(*TesselA) << ", " << *(*TesselB) << " and " << *(*TesselC) << ":" << helper);
+    LOG(5, "DEBUG: Making normal vector out of " << *(*TesselA) << ", " << *(*TesselB) << " and " << *(*TesselC) << ":" << helper);
     counter++;
     TesselA++;
@@ -2874,5 +2880,5 @@
   //  PlaneNormal.SubtractVector(&center);
   //  PlaneNormal.Normalize();
-  LOG(1, "INFO: Calculated plane normal of circle is " << PlaneNormal << ".");
+  LOG(4, "DEBUG: Calculated plane normal of circle is " << PlaneNormal << ".");
 
   // construct one orthogonal vector
@@ -2882,5 +2888,5 @@
   }
   if ((Reference.IsZero()) || (AngleZero.NormSquared() < MYEPSILON )) {
-    LOG(1, "Using alternatively " << (*SetOfNeighbours->begin())->getPosition() << " as angle 0 referencer.");
+    LOG(4, "DEBUG: Using alternatively " << (*SetOfNeighbours->begin())->getPosition() << " as angle 0 referencer.");
     AngleZero = ((*SetOfNeighbours->begin())->getPosition()) - (Point->getPosition());
     AngleZero.ProjectOntoPlane(PlaneNormal);
@@ -2890,10 +2896,10 @@
     }
   }
-  LOG(1, "INFO: Reference vector on this plane representing angle 0 is " << AngleZero << ".");
+  LOG(4, "DEBUG: Reference vector on this plane representing angle 0 is " << AngleZero << ".");
   if (AngleZero.NormSquared() > MYEPSILON)
     OrthogonalVector = Plane(PlaneNormal, AngleZero,0).getNormal();
   else
     OrthogonalVector.MakeNormalTo(PlaneNormal);
-  LOG(1, "INFO: OrthogonalVector on plane is " << OrthogonalVector << ".");
+  LOG(4, "DEBUG: OrthogonalVector on plane is " << OrthogonalVector << ".");
 
   // go through all connected points and calculate angle
@@ -2905,5 +2911,5 @@
     if (angle > M_PI) // the correction is of no use here (and not desired)
       angle = 2. * M_PI - angle;
-    LOG(0, "INFO: Calculated angle between " << helper << " and " << AngleZero << " is " << angle << " for point " << **listRunner << ".");
+    LOG(4, "DEBUG: Calculated angle between " << helper << " and " << AngleZero << " is " << angle << " for point " << **listRunner << ".");
     InserterTest = anglesOfPoints.insert(pair<double, TesselPoint*> (angle, (*listRunner)));
     if (!InserterTest.second) {
@@ -2928,5 +2934,5 @@
 ListOfTesselPointList * Tesselation::GetPathsOfConnectedPoints(const TesselPoint* const Point) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   map<double, TesselPoint*> anglesOfPoints;
   list<TesselPointList *> *ListOfPaths = new list<TesselPointList *> ;
@@ -3043,5 +3049,5 @@
 ListOfTesselPointList * Tesselation::GetClosedPathsOfConnectedPoints(const TesselPoint* const Point) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   list<TesselPointList *> *ListofPaths = GetPathsOfConnectedPoints(Point);
   list<TesselPointList *> *ListofClosedPaths = new list<TesselPointList *> ;
@@ -3107,5 +3113,5 @@
 TriangleSet *Tesselation::GetAllTriangles(const BoundaryPointSet * const Point) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   TriangleSet *connectedTriangles = new TriangleSet;
 
@@ -3147,5 +3153,5 @@
     return 0.;
   } else
-    LOG(0, "Removing point " << *point << " from tesselated boundary ...");
+    LOG(4, "DEBUG: Removing point " << *point << " from tesselated boundary ...");
 
   // copy old location for the volume
@@ -3328,5 +3334,5 @@
       delete (connectedPath);
     }
-    LOG(0, count << " triangles were created.");
+    LOG(1, "INFO: " << count << " triangles were created.");
   } else {
     while (!ListOfClosedPaths->empty()) {
@@ -3336,9 +3342,9 @@
       delete (connectedPath);
     }
-    LOG(0, "No need to create any triangles.");
+    LOG(3, "DEBUG: No need to create any triangles.");
   }
   delete (ListOfClosedPaths);
 
-  LOG(0, "Removed volume is " << volume << ".");
+  LOG(1, "INFO: Removed volume is " << volume << ".");
 
   return volume;
@@ -3356,5 +3362,5 @@
 TriangleList *Tesselation::FindTriangles(const TesselPoint* const Points[3]) const
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   TriangleList *result = new TriangleList;
   LineMap::const_iterator FindLine;
@@ -3484,5 +3490,5 @@
 IndexToIndex * Tesselation::FindAllDegeneratedLines()
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   UniqueLines AllLines;
   IndexToIndex * DegeneratedLines = new IndexToIndex;
@@ -3505,5 +3511,5 @@
   AllLines.clear();
 
-  LOG(0, "FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines.");
+  LOG(2, "DEBUG: FindAllDegeneratedLines() found " << DegeneratedLines->size() << " lines.");
   IndexToIndex::iterator it;
   for (it = DegeneratedLines->begin(); it != DegeneratedLines->end(); it++) {
@@ -3511,5 +3517,5 @@
     const LineMap::const_iterator Line2 = LinesOnBoundary.find((*it).second);
     if (Line1 != LinesOnBoundary.end() && Line2 != LinesOnBoundary.end())
-      LOG(0, *Line1->second << " => " << *Line2->second);
+      LOG(3, "DEBUG: " << *Line1->second << " => " << *Line2->second);
     else
       ELOG(1, "Either " << (*it).first << " or " << (*it).second << " are not in LinesOnBoundary!");
@@ -3527,5 +3533,5 @@
 IndexToIndex * Tesselation::FindAllDegeneratedTriangles()
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   IndexToIndex * DegeneratedLines = FindAllDegeneratedLines();
   IndexToIndex * DegeneratedTriangles = new IndexToIndex;
@@ -3553,7 +3559,7 @@
   delete (DegeneratedLines);
 
-  LOG(0, "FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:");
+  LOG(3, "DEBUG: FindAllDegeneratedTriangles() found " << DegeneratedTriangles->size() << " triangles:");
   for (IndexToIndex::iterator it = DegeneratedTriangles->begin(); it != DegeneratedTriangles->end(); it++)
-    LOG(0, (*it).first << " => " << (*it).second);
+    LOG(3, "DEBUG:    " << (*it).first << " => " << (*it).second);
 
   return DegeneratedTriangles;
@@ -3566,5 +3572,5 @@
 void Tesselation::RemoveDegeneratedTriangles()
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   IndexToIndex * DegeneratedTriangles = FindAllDegeneratedTriangles();
   TriangleMap::iterator finder;
@@ -3574,5 +3580,5 @@
   // iterate over all degenerated triangles
   for (IndexToIndex::iterator TriangleKeyRunner = DegeneratedTriangles->begin(); !DegeneratedTriangles->empty(); TriangleKeyRunner = DegeneratedTriangles->begin()) {
-    LOG(0, "Checking presence of triangles " << TriangleKeyRunner->first << " and " << TriangleKeyRunner->second << ".");
+    LOG(3, "DEBUG: Checking presence of triangles " << TriangleKeyRunner->first << " and " << TriangleKeyRunner->second << ".");
     // both ways are stored in the map, only use one
     if (TriangleKeyRunner->first > TriangleKeyRunner->second)
@@ -3631,11 +3637,11 @@
       // erase the pair
       count += (int) DegeneratedTriangles->erase(triangle->Nr);
-      LOG(0, "RemoveDegeneratedTriangles() removes triangle " << *triangle << ".");
+      LOG(4, "DEBUG: RemoveDegeneratedTriangles() removes triangle " << *triangle << ".");
       RemoveTesselationTriangle(triangle);
       count += (int) DegeneratedTriangles->erase(partnerTriangle->Nr);
-      LOG(0, "RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << ".");
+      LOG(4, "DEBUG: RemoveDegeneratedTriangles() removes triangle " << *partnerTriangle << ".");
       RemoveTesselationTriangle(partnerTriangle);
     } else {
-      LOG(0, "RemoveDegeneratedTriangles() does not remove triangle " << *triangle << " and its partner " << *partnerTriangle << " because it is essential for at" << " least one of the endpoints to be kept in the tesselation structure.");
+      LOG(4, "DEBUG: RemoveDegeneratedTriangles() does not remove triangle " << *triangle << " and its partner " << *partnerTriangle << " because it is essential for at" << " least one of the endpoints to be kept in the tesselation structure.");
     }
   }
@@ -3644,5 +3650,5 @@
     LastTriangle = NULL;
 
-  LOG(0, "RemoveDegeneratedTriangles() removed " << count << " triangles:");
+  LOG(2, "INFO: RemoveDegeneratedTriangles() removed " << count << " triangles:");
 }
 
@@ -3657,5 +3663,5 @@
 void Tesselation::AddBoundaryPointByDegeneratedTriangle(class TesselPoint *point, LinkedCell_deprecated *LC)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   // find nearest boundary point
   class TesselPoint *BackupPoint = NULL;
@@ -3673,5 +3679,5 @@
     return;
   }
-  LOG(0, "Nearest point on boundary is " << NearestPoint->getName() << ".");
+  LOG(3, "DEBUG: Nearest point on boundary is " << NearestPoint->getName() << ".");
 
   // go through its lines and find the best one to split
@@ -3755,5 +3761,5 @@
 void Tesselation::Output(const char *filename, IPointCloud & cloud)
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   ofstream *tempstream = NULL;
   string NameofTempFile;
@@ -3829,5 +3835,5 @@
 int Tesselation::CorrectAllDegeneratedPolygons()
 {
-  Info FunctionInfo(__func__);
+  //Info FunctionInfo(__func__);
   /// 2. Go through all BoundaryPointSet's, check their triangles' NormalVector
   IndexToIndex *DegeneratedTriangles = FindAllDegeneratedTriangles();
@@ -3836,8 +3842,8 @@
   pair<map<int, Vector *>::iterator, bool> TriangleInsertionTester;
   for (PointMap::const_iterator Runner = PointsOnBoundary.begin(); Runner != PointsOnBoundary.end(); Runner++) {
-    LOG(0, "Current point is " << *Runner->second << ".");
+    LOG(3, "DEBUG: Current point is " << *Runner->second << ".");
     map<int, Vector *> TriangleVectors;
     // gather all NormalVectors
-    LOG(1, "Gathering triangles ...");
+    LOG(4, "DEBUG: Gathering triangles ...");
     for (LineMap::const_iterator LineRunner = (Runner->second)->lines.begin(); LineRunner != (Runner->second)->lines.end(); LineRunner++)
       for (TriangleMap::const_iterator TriangleRunner = (LineRunner->second)->triangles.begin(); TriangleRunner != (LineRunner->second)->triangles.end(); TriangleRunner++) {
@@ -3845,20 +3851,20 @@
           TriangleInsertionTester = TriangleVectors.insert(pair<int, Vector *> ((TriangleRunner->second)->Nr, &((TriangleRunner->second)->NormalVector)));
           if (TriangleInsertionTester.second)
-            LOG(1, " Adding triangle " << *(TriangleRunner->second) << " to triangles to check-list.");
+            LOG(5, "DEBUG:  Adding triangle " << *(TriangleRunner->second) << " to triangles to check-list.");
         } else {
-          LOG(1, " NOT adding triangle " << *(TriangleRunner->second) << " as it's a simply degenerated one.");
+          LOG(5, "DEBUG:  NOT adding triangle " << *(TriangleRunner->second) << " as it's a simply degenerated one.");
         }
       }
     // check whether there are two that are parallel
-    LOG(1, "Finding two parallel triangles ...");
+    LOG(3, "DEBUG: Finding two parallel triangles ...");
     for (map<int, Vector *>::iterator VectorWalker = TriangleVectors.begin(); VectorWalker != TriangleVectors.end(); VectorWalker++)
       for (map<int, Vector *>::iterator VectorRunner = VectorWalker; VectorRunner != TriangleVectors.end(); VectorRunner++)
         if (VectorWalker != VectorRunner) { // skip equals
           const double SCP = VectorWalker->second->ScalarProduct(*VectorRunner->second); // ScalarProduct should result in -1. for degenerated triangles
-          LOG(1, "Checking " << *VectorWalker->second << " against " << *VectorRunner->second << ": " << SCP);
+          LOG(4, "DEBUG: Checking " << *VectorWalker->second << " against " << *VectorRunner->second << ": " << SCP);
           if (fabs(SCP + 1.) < ParallelEpsilon) {
             InsertionTester = EndpointCandidateList.insert((Runner->second));
             if (InsertionTester.second)
-              LOG(0, " Adding " << *Runner->second << " to endpoint candidate list.");
+              LOG(4, "DEBUG:  Adding " << *Runner->second << " to endpoint candidate list.");
             // and break out of both loops
             VectorWalker = TriangleVectors.end();
@@ -3879,5 +3885,5 @@
     Walker = *(EndpointCandidateList.begin());
     if (Current == NULL) { // create a new polygon with current candidate
-      LOG(0, "Starting new polygon set at point " << *Walker);
+      LOG(3, "DEBUG: Starting new polygon set at point " << *Walker);
       Current = new BoundaryPolygonSet;
       Current->endpoints.insert(Walker);
@@ -3892,18 +3898,18 @@
       for (LineMap::const_iterator LineWalker = Walker->lines.begin(); LineWalker != Walker->lines.end(); LineWalker++) {
         OtherWalker = (LineWalker->second)->GetOtherEndpoint(Walker);
-        LOG(1, "Checking " << *OtherWalker);
+        LOG(4, "DEBUG: Checking " << *OtherWalker);
         set<BoundaryPointSet *>::iterator Finder = EndpointCandidateList.find(OtherWalker);
         if (Finder != EndpointCandidateList.end()) { // found a connected partner
-          LOG(1, " Adding to polygon.");
+          LOG(5, "DEBUG:  Adding to polygon.");
           Current->endpoints.insert(OtherWalker);
           EndpointCandidateList.erase(Finder); // remove from candidates
           ToCheckConnecteds.push(OtherWalker); // but check its partners too
         } else {
-          LOG(1, " is not connected to " << *Walker);
+          LOG(5, "DEBUG:  is not connected to " << *Walker);
         }
       }
     }
 
-    LOG(0, "Final polygon is " << *Current);
+    LOG(3, "DEBUG: Final polygon is " << *Current);
     ListofDegeneratedPolygons.insert(Current);
     Current = NULL;
@@ -3917,5 +3923,5 @@
     for (UniquePolygonSet::iterator PolygonRunner = ListofDegeneratedPolygons.begin(); PolygonRunner != ListofDegeneratedPolygons.end(); PolygonRunner++)
       output << " " << **PolygonRunner;
-    LOG(0, output.str());
+    LOG(3, "DEBUG: " << output.str());
   }
 
@@ -3929,5 +3935,5 @@
     // check whether number is bigger than 2, otherwise it's just a simply degenerated one and nothing to do.
     if (T->size() == 2) {
-      LOG(1, " Skipping degenerated polygon, is just a (already simply degenerated) triangle.");
+      LOG(4, "DEBUG:  Skipping degenerated polygon, is just a (already simply degenerated) triangle.");
       delete (T);
       continue;
@@ -3945,5 +3951,5 @@
     /// 4a. Get NormalVector for one side (this is "front")
     NormalVector = (*TriangleWalker)->NormalVector;
-    LOG(1, "\"front\" defining triangle is " << **TriangleWalker << " and Normal vector of \"front\" side is " << NormalVector);
+    LOG(4, "DEBUG: \"front\" defining triangle is " << **TriangleWalker << " and Normal vector of \"front\" side is " << NormalVector);
     TriangleWalker++;
     TriangleSet::iterator TriangleSprinter = TriangleWalker; // is the inner advanced iterator
@@ -3954,17 +3960,17 @@
       triangle = *TriangleWalker;
       TriangleSprinter++;
-      LOG(1, "Current triangle to test for removal: " << *triangle);
+      LOG(4, "DEBUG: Current triangle to test for removal: " << *triangle);
       if (triangle->NormalVector.ScalarProduct(NormalVector) < 0) { // if from other side, then delete and remove from list
-        LOG(1, " Removing ... ");
+        LOG(5, "DEBUG:  Removing ... ");
         TriangleNrs.push(triangle->Nr);
         T->erase(TriangleWalker);
         RemoveTesselationTriangle(triangle);
       } else
-        LOG(1, " Keeping ... ");
+        LOG(5, "DEBUG:  Keeping ... ");
     }
     /// 4c. Copy all "front" triangles but with inverse NormalVector
     TriangleWalker = T->begin();
     while (TriangleWalker != T->end()) { // go through all front triangles
-      LOG(1, " Re-creating triangle " << **TriangleWalker << " with NormalVector " << (*TriangleWalker)->NormalVector);
+      LOG(4, "DEBUG:  Re-creating triangle " << **TriangleWalker << " with NormalVector " << (*TriangleWalker)->NormalVector);
       for (int i = 0; i < 3; i++)
         AddTesselationPoint((*TriangleWalker)->endpoints[i]->node, i);
@@ -3986,8 +3992,8 @@
   }
   IndexToIndex * SimplyDegeneratedTriangles = FindAllDegeneratedTriangles();
-  LOG(0, "Final list of simply degenerated triangles found, containing " << SimplyDegeneratedTriangles->size() << " triangles:");
+  LOG(2, "DEBUG: Final list of simply degenerated triangles found, containing " << SimplyDegeneratedTriangles->size() << " triangles:");
   IndexToIndex::iterator it;
   for (it = SimplyDegeneratedTriangles->begin(); it != SimplyDegeneratedTriangles->end(); it++)
-    LOG(0, (*it).first << " => " << (*it).second);
+    LOG(2, "DEBUG:   " << (*it).first << " => " << (*it).second);
   delete (SimplyDegeneratedTriangles);
   /// 5. exit
